var window = this;
window.Log = function() {
    function log(msg, level, tag) {
        if (typeof tag === 'undefined') {
            tag = "";
        }
        var jsonx = {"msg" : msg,"tag":tag,"level":level};
        Bridge.performNativeMethod("Log", "log", JSON.stringify(jsonx));
    }
    var Log = {
        d: function d(msg, tag) {
            log(msg, 3, tag);
        },
        e: function e(msg, tag) {
            log(msg, 6, tag);
        },
        i: function i(msg, tag) {
            log(msg, 4, tag);
        },
        v: function v(msg, tag) {
            log(msg, 2, tag);
        },
        w: function w(msg, tag) {
            log(msg, 5, tag);
        }
    };
    return Log;
}();
window.ModuleLoader = function() {
    var modules = Object.create(null);
    var ModuleLoader = {
        loadModule: function loadModule(moduleName) {
            var module = modules[moduleName];
            if (module) {
                if (!module.isInitialized) {
                    module.factory(module);
                    module.isInitialized = true;
                    window[moduleName] = module.exports;
                }
                return module.exports;
            } else {
                Log.e('Unknow module: ' + module);
            }
        },
        define: function define(factory, moduleId) {
            if (moduleId in modules) {
                return;
            }
            modules[moduleId] = {
                exports: undefined,
                factory: factory,
                isInitialized: false
            };
        }
    };
    return ModuleLoader;
}();

window.Callback = function() {
    var _callID = 0;
    var _callbacks = {};
    var Callback = {
        addCallback: function addCallback(onCallback) {
            var cbID = 0;
            if (onCallback) {
                _callID++;
                cbID = _callID;
                _callbacks[cbID] = onCallback;
            }
            return cbID;
        },
        trigger: function addCallback(args) {
            var callID = args.shift();
            var isSuccess = args.shift();
            var callback = _callbacks[callID];
            if (!callback) {
                Log.d("trigger: can't find callID: " + callID, "Callback");
                return;
            }
            callback.apply(null, args);
            delete _callbacks[callID];
        }
    };

    return Callback;
}();

window.Bridge = function() {
    function callMethod(module, method, args) {
        if (module === "Callback") {
            Log.d("Call Callback", "Bridge");
            Callback.trigger(args);
        } else {
            var moduleExports = window.ModuleLoader.loadModule(module);
            Log.d("Call module[" + module + "] method[" + method + "]", "Bridge");
            if (moduleExports) {
                var result = moduleExports[method].apply(moduleExports, args);
            }
        }
    }

    var Bridge = {
   	  // native call js
   		onNativeCallMethod: function onNativeCallMethod(module, method) {
   		    var args = new Array()
   			  for(var i = 2,j = 0; i < arguments.length; i++) {
   			      if(Array.isArray(arguments[i])){
           	      for(var k = 0; k < arguments[i].length; k++){
           	          args[j++] = arguments[i][k];
           	      }
   			      }else{
   			          args[j++] = arguments[i];
   			      }
   			  }
   			  callMethod(module, method, args);
     },
     // js call native
     performNativeMethod: function performNativeMethod(moduleName, methodName, argsJson, onCallback, moduleid) {
        jniBridge.onJSCallMethod(moduleName, methodName, argsJson, Callback.addCallback(onCallback), moduleid);
    }
   };
   return Bridge;
}();

window.__d = window.ModuleLoader.define;
window.require = window.ModuleLoader.loadModule;

__d(function(module) {
    var assignedId = 0;
    function addNativeId(json, pid, vueIdToNativeId, nativeIdToViewObject, script) {
        for (var item in json) {
            if (json[item] instanceof Array) {
                addNativeId(json[item], pid, vueIdToNativeId, nativeIdToViewObject, script);
            } else if (typeof json[item] === 'object') {
                if (!(typeof json[item]["type"] === 'undefined')) {
                    if (typeof json[item]["nativeId"] === 'undefined') {
                        assignedId = assignedId + 1;
                        json[item]["nativeId"] = assignedId;
                    }
                    if (typeof json[item]["pid"] === 'undefined') {
                        json[item]["pid"] = pid;
                    }
                    vueIdToNativeId[json[item]["id"]] = json[item]["nativeId"];
                    if (!(typeof json[item]["events"] === 'undefined')) {
                        for (var action in json[item]["events"]) {
                            json[item][action] = script[json[item]["events"][action]];
                        }
                    }
                    nativeIdToViewObject[json[item]["nativeId"]] = json[item];
                    addNativeId(json[item], json[item]["nativeId"], vueIdToNativeId, nativeIdToViewObject, script);
                }
            }
        }
    }
    var NativeIDCreater = {
        parse: function generateNativeId(jsonStr, pid) {
            if (typeof pid === 'undefined') {
                pid = 0;
            }
            if (typeof jsonStr === 'string' || jsonStr instanceof String) {
                json = JSON.parse(jsonStr);
            } else {
                json = jsonStr;
            }
            var vueIdToNativeId = {};
            var nativeIdToViewObject = {};
            addNativeId(json, pid, vueIdToNativeId, nativeIdToViewObject, json["script"]);
            Log.d("Final Result: " + JSON.stringify(json), "NativeIDCreater");
            return {"json": json, "idMapNativeId": vueIdToNativeId, "nativeIdMapViewObject": nativeIdToViewObject};
        }
    };
    module.exports = NativeIDCreater;
}, "NativeIDCreater");

__d(function(module) {
    require("NativeIDCreater");
    require("View");
    require("Toast");
    var nativeIdToViewObject = {};
    var vueIdToNativeId = {};
    var ViewCreater = {
        create: function create(json) {
    Log.d("ViewCreater create source json  : " + JSON.stringify(json), "Person");
    // parse 1. create native id 2. vue id to native id map 3. native id to view map
    var result = NativeIDCreater.parse(json);
    // vue id to native id map
    var tempMap = result["idMapNativeId"];
    for (var attrname in tempMap) {
        vueIdToNativeId[attrname] = tempMap[attrname];
    }
    var nextTempMap = result["nativeIdMapViewObject"];
    for (var attrname in nextTempMap) {
        nativeIdToViewObject[attrname] = nextTempMap[attrname];
    }
    headIconNativeId = vueIdToNativeId["headIcon"];
    /*var btnObj = new Object();
     btnObj.onClick = function(params, params2) {
     Log.d("Btn click: " + params + " | " + params2, "Button");
     Toast.show("Btn click");
     };
     nativeIdToViewObject["112"] = btnObj;*/
    // call to native
    View.add(result["json"]);
    return result["json"];
},
getByNativeId: function getByNativeId(nativeId) {
    return nativeIdToViewObject[nativeId];
},
getVueIdByNativeId:function getByNativeId(nativeId) {
    var viewObj = nativeIdToViewObject[nativeId];
    return viewObj["id"];
},
get: function get(vueId) {
    var nativeId = vueIdToNativeId[vueId]
    return nativeIdToViewObject[nativeId];
},
};
module.exports = ViewCreater;
}, "ViewCreater");

__d(function(module) {
    require("ViewCreater");
    var EventDispatcher = {
        dispatch: function dispatch(nativeId, eventType, args) {

            var viewObj = ViewCreater.getByNativeId(nativeId);
            Log.d("EventDispatcher viewObjc == "+JSON.stringify(viewObj)+" eventType == "+ JSON.stringify(eventType),"Person");
            if (viewObj) {
                var vueId = ViewCreater.getVueIdByNativeId(nativeId);
                if (typeof args === 'undefined') {
                    args = [vueId];
                }
                if (!(args instanceof Array)) {
                    var params = [vueId];
                    for(var i = 0; i < arguments.length; i++) {
                        if (i != 0 && i != 1) {
                            params[i - 1] = arguments[i];
                        }
                    }
                    args = params;
                }
//    var result = viewObj[eventType].apply(viewObj, args);
var func = viewObj["events"][eventType];
Log.d("EventDispatcher func ==" + JSON.stringify(func),"Person");
var result = profileTemplate["script"][func].apply(viewObj, args);
}
}
};
module.exports = EventDispatcher;
}, "EventDispatcher");

__d(function(module) {
    var listeners = [];
    var Lifecycle = {
        addListener: function addListener(listener) {
            if(listener instanceof LifecycleListener) {
                listeners.push(listener);
            } else {
                Log.e("listener isn't LifecycleListener", "Lifecycle");
            }
        },
        notify: function notify(eventType) {
            for (var i = 0; i < listeners.length; i++) {
                var listener = listeners[i];
                if (listener) {
                    var result = listener[eventType].apply(listener, []);
                }
            }
        }
    };
    module.exports = Lifecycle;
}, "Lifecycle");

// javascript 继承方案, 参考 http://www.infoq.com/cn/articles/javascript-instantiation-and-inheritance
// 基类
function Class() {}

// 将extend和create置于prototype对象中，以便子类继承
Class.prototype.extend = function () {};
Class.prototype.create = function () {};

// 为了能在基类上直接以.extend的方式进行调用
Class.extend = function (props) {
    return this.prototype.extend.call(this, props);
}

Class.prototype.create = function (props) {
    /*
     create实际上是对new的封装；
     create返回的实例实际上就是new构造出的实例；
     this即指向调用当前create的构造函数；
     */
     var instance = new this();
    /*
     绑定该实例的属性
     */
     for (var name in props) {
        instance[name] = props[name];
    }
    return instance;
}

Class.prototype.extend = function (props) {
    /*
     派生出来的新的子类
     */
     var SubClass = function () {};
    /*
     继承父类的属性和方法，
     当然前提是父类的属性都放在prototype中
     而非上面create方法的“实例属性”中
     */
     SubClass.prototype = Object.create(this.prototype);
    // 并且添加自己的方法和属性
    for (var name in props) {
        SubClass.prototype[name] = props[name];
    }
    SubClass.prototype.constructor = SubClass;

    /*
     介于需要以.extend的方式和.create的方式调用：
     */
     SubClass.extend = SubClass.prototype.extend;
     SubClass.create = SubClass.prototype.create;

     return SubClass;
 }

 var LifecycleListener = Class.extend({
   onResume: function () {
       Log.d("onResume", "LifecycleListener");
   },
   onPause: function () {
       Log.d("onPause", "LifecycleListener");
   },
   onDestroy: function () {
       Log.d("onDestroy", "LifecycleListener");
   },
});

 __d(function(module) {
    var Button = {
        onClick: function onClick(params) {
            Log.d("Btn click", "Button");
        }
    };
    module.exports = Button;
}, "Button");

 __d(function(module) {
    var View = {
        add: function add(json) {
            if (typeof json === 'string' || json instanceof String) {
                jsonStr = json;
            } else {
                jsonStr = JSON.stringify(json);
            }
            var jsonx = {"json" : jsonStr};
            Bridge.performNativeMethod("View", "add", JSON.stringify(jsonx));
        }
    };
    module.exports = View;
}, "View");

 __d(function(module) {
    var Toast = {
        show: function show(msg) {
            var jsonx = {"msg" : msg};
            Bridge.performNativeMethod("Toast", "show",JSON.stringify(jsonx));
        }
    };
    module.exports = Toast;
}, "Toast");

 __d(function(module) {
    var CallbackTest = {
        test: function test(onCallback) {
            Bridge.performNativeMethod("CallbackTest", "test", "", onCallback);
        }
    };
    module.exports = CallbackTest;
}, "CallbackTest");

 __d(function(module) {
    var EMail = {
        send: function send(to, subject, body) {
            var jsonx = {"to" : to,"subject":subject,"body":body};
            Bridge.performNativeMethod("EMail", "send",JSON.stringify(jsonx));
        }
    };
    module.exports = EMail;
}, "EMail");

 __d(function(module) {
    var Phone = {
        call: function call(phone) {
            var jsonx = {"phone" : phone};
            Bridge.performNativeMethod("Phone", "call",JSON.stringify(jsonx));
        }
    };
    module.exports = Phone;
}, "Phone");

 __d(function(module) {
    var Page = {
        popPage: function popPage() {
            Bridge.performNativeMethod("Page", "popPage", "");
        },
     /*
      args:{"uin":"2355200974", "type":"inside"(或者"outside")}
      */
        openNewPage: function openNewPage(iOS_page,android_page,requestCode,args) {
     var jsonx = {"iOS_class" : iOS_page, "android_page" : android_page, "requestCode": requestCode, "args" : args};
            Bridge.performNativeMethod("Page", "openNewPage",JSON.stringify(jsonx));
        }
    };
    module.exports = Page;
}, "Page");

 __d(function(module) {
    var _timerID = 0;
    function TimerHandler(id, fun, time) {
        var _id = id;
        var _fun = fun;
        var _time = time;
        var _timerHandler = {
            stop: function stop() {
                var jsonx = {"id" : _id};
                Bridge.performNativeMethod("Timer", "stop", JSON.stringify(jsonx), _fun);
            },
            start: function start() {
                var jsonx = {"id" : _id, "time": _time};
                Bridge.performNativeMethod("Timer", "start", JSON.stringify(jsonx), _fun);
            }
        };
        return _timerHandler;
    }
    var Timer = {
        setTimeout: function setTimeout(fun, time) {
            _timerID++;
            var handler = new TimerHandler(_timerID, fun, time);
            handler.start();
            return handler;
        },
        clearTimeout: function clearTimeout(handler) {
            handler.stop();
        }
    };
    module.exports = Timer;
}, "Timer");

 __d(function(module) {
    var _personStruct = "";
    var PearlLoadData = {
        loadDataFromNet: function loadDataFromNet(uin, onCallback) {
            var jsonx = {"uin" : uin};
            Bridge.performNativeMethod("PearlLoadData", "requestCardDataFromNet",JSON.stringify(jsonx), onCallback);
        },
        loadDataFromDB: function loadDataFromDB(uin, onCallback) {
            var jsonx = {"uin" : uin};
            Bridge.performNativeMethod("PearlLoadData", "requestCardDataFromDB", JSON.stringify(jsonx), onCallback);
        },
        loadDataFromPreview: function loadDataFromPreview(uin, onCallback) {
            var jsonx = {"uin" : uin};
            Bridge.performNativeMethod("PearlLoadData", "requestCardDataFromPreview", JSON.stringify(jsonx), onCallback);
        },
        onLoaded: function(json,isChangeInside) {
            if (json != "") _personStruct = new PersonStruct(json,isChangeInside);
            if(_personStruct == "") return;
            var oldUiJson = _personStruct.getUiJson();
             if (gIsVKShow) {
                oldUiJson["style"]["profile"]["height"] = 1334 - gVKHeight;
                oldUiJson["style"]["innerProfile"]["height"] = 1206 - gVKHeight;
                oldUiJson["style"]["outerProfile"]["height"] = 1206 - gVKHeight;
                if(gIsShowSelfPreview){
                  oldUiJson["style"]["pearlListBox"]["height"] = 846 - gVKHeight;
                }else{
                  oldUiJson["style"]["pearlListBox"]["height"] = 738 - gVKHeight;
                }
              } else {
                oldUiJson["style"]["profile"]["height"] = 1334;
                oldUiJson["style"]["innerProfile"]["height"] = 1206;
                oldUiJson["style"]["outerProfile"]["height"] = 1206;
                if(gIsShowSelfPreview){
                  oldUiJson["style"]["pearlListBox"]["height"] = 846;
                }else{
                  oldUiJson["style"]["pearlListBox"]["height"] = 738;
                }
              }
              _personStruct.setUiJson(oldUiJson);
            var newUiJsonstr = ViewCreater.create(oldUiJson);
            _personStruct.setUiJson(newUiJsonstr);
        },
        getUiJson: function() {
            if (_personStruct != "") {
                return _personStruct.getUiJson();
            }
            return "";
        }
    };
    module.exports = PearlLoadData;
}, "PearlLoadData");

 __d(function(module) {
    var PearlOrganization = {
        jumpTo: function jumpTo(backTxt,depUid) {
            var jsonx = {"backTxt" : backTxt,"depUid":depUid};
            Bridge.performNativeMethod("PearlOrganization", "jumpTo",JSON.stringify(jsonx));
        }
    };
    module.exports = PearlOrganization;
}, "PearlOrganization");

 __d(function(module) {
    var PearlOpenAIO = {
        openAioFromCard: function openAioFromCard(uin,nickName) {
            var jsonx = {"uin" : uin,"nickName":nickName};
            Bridge.performNativeMethod("PearlOpenAIO", "openAioFromCard",JSON.stringify(jsonx));
        }
    };
    module.exports = PearlOpenAIO;
}, "PearlOpenAIO");

__d(function(module) {
    var PearlFavContact = {
        pearlAddFavContact: function pearlAddFavContact(uin) {
        var jsonx = {"colleagueUin" : uin};
        Bridge.performNativeMethod("PearlFavContact", "pearlAddFavContact",JSON.stringify(jsonx));
        },
        pearlDelFavContact: function pearlDelFavContact(uin) {
        var jsonx = {"colleagueUin" : uin};
        Bridge.performNativeMethod("PearlFavContact", "pearlDelFavContact",JSON.stringify(jsonx));
        },
    };
    module.exports = PearlFavContact;
}, "PearlFavContact");

 __d(function(module) {
    var PearlMultiPhone = {
        enterQQPhoneFromCard: function enterQQPhoneFromCard(uin,name) {
            var jsonx = {"uin" : uin,"name":name};
            Bridge.performNativeMethod("PearlMultiPhone", "enterQQPhoneFromCard",JSON.stringify(jsonx));
        },
        openBindMobile: function openBindMobile() {
            Bridge.performNativeMethod("PearlMultiPhone", "openBindMobile",undefined);
        },
    };
    module.exports = PearlMultiPhone;
}, "PearlMultiPhone");

 __d(function(module) {
    var PearlActionSheet = {
        showCardSheet: function showCardSheet(title,cancelName,jsonWrapper,phoneNum,uin,callName) {
            var jsonx = {"title" : title,"cancelName":cancelName,"jsonWrapper":jsonWrapper,"phoneNum":phoneNum,"uin":uin,"callName":callName};
            Bridge.performNativeMethod("PearlActionSheet", "showCardSheet",JSON.stringify(jsonx));
        }
    };
    module.exports = PearlActionSheet;
}, "PearlActionSheet");

 __d(function(module) {
    var PearlAvatar = {
        viewAvatar: function viewAvatar(uin,nativeId) {
            var jsonx = {"uin":uin,"nativeId":nativeId};
            Bridge.performNativeMethod("PearlAvatar", "viewAvatar",JSON.stringify(jsonx));
        }
    };
    module.exports = PearlAvatar;
}, "PearlAvatar");

/*
 __d(function(module) {
    require("ViewCreater");
    var EventDispatcher = {
        dispatch: function dispatch(nativeId, eventType, args) {

            var viewObj = ViewCreater.getByNativeId(nativeId);


            if (viewObj) {
                var vueId = ViewCreater.getVueIdByNativeId(nativeId);
                if (typeof args === 'undefined') {
                    args = [vueId];
                }
                if (!(args instanceof Array)) {
                    var params = [vueId];
                    for(var i = 0; i < arguments.length; i++) {
                        if (i != 0 && i != 1) {
                            params[i - 1] = arguments[i];
                        }
                    }
                    args = params;
                }
//    var result = viewObj[eventType].apply(viewObj, args);
var func = viewObj["events"][eventType];
var result = profileTemplate["script"][func].apply(viewObj, args);
}
}
};
module.exports = EventDispatcher;
}, "EventDispatcher");
*/
var gIsVKShow = false;
var gVKHeight = 0;
__d(function(module) {
    require("PearlLoadData");
    require("Toast");
    var VirtualKey = {
        onChange: function onChange(isVKShow, VKHeight) {
          gIsVKShow = isVKShow;
          gVKHeight = VKHeight;
			    PearlLoadData.onLoaded("",false);
        }
    };
    module.exports = VirtualKey;
}, "VirtualKey");


 __d(function(module) {
    require("ViewCreater");

    var ProfileSwitcher = {

        switchInternalProfile:function switchInternalProfile()
        {
            var style = currentProfileJson.style;
            delete style.innerProfile.display;
            style.outerProfile.display = "none";

            currentProfileJson.template.children[1].children[0].children[0].classList[0] = "segmentLeftUnselectedItem";
            currentProfileJson.template.children[1].children[0].children[1].classList[0] = "segmentRightSelectedItem";

            Log.d("ProfileSwitcher switchInternalProfile: " + JSON.stringify(style), "Person");

        },
        showInternalProfile: function showInternalProfile()
        {
            ProfileSwitcher.switchInternalProfile();

            currentProfileJson = ViewCreater.create(currentProfileJson);


        },

        switchExternalProfile:function switchExternalProfile()
        {
            var style = currentProfileJson.style;
            delete style.outerProfile.display;
            style.innerProfile.display = "none";

            currentProfileJson.template.children[1].children[0].children[0].classList[0] = "segmentLeftSelectedItem";
            currentProfileJson.template.children[1].children[0].children[1].classList[0] = "segmentRightUnselectedItem";

            Log.d("ProfileSwitcher showExternalProfile: " + JSON.stringify(style), "Person");

        },
        showExternalProfile: function showExternalProfile()
        {
            ProfileSwitcher.switchExternalProfile();

            currentProfileJson = ViewCreater.create(currentProfileJson);
        },
    };

    module.exports = ProfileSwitcher;
},"ProfileSwitcher");
//UI模版
var profileTemplate =

{"style":{
    "profile": {
        "position": "absolute",
        "width": 750,
        "height": 1334
    },
    "innerProfile": {
        "position": "absolute",
        "top": 88,
        "width": 750,
        "height": 1206,
        "display": "none"
    },
    "outerProfile": {
        "position": "absolute",
        "top": 88,
        "width": 750,
        "height": 1206
    },
    "statusBar": {
        "position": "absolute",
        "width": 750,
        "height": 0,
        "top": 0,
        "backgroundColor": "#0c5cfa"
    },
    "navigationBar": {
        "position": "absolute",
        "height": 88,
        "width": 750,
        "top": 0,
        "display": "flex",
        "flexDirection": "row",
        "alignItems": "center",
        "justifyContent": "center",
        "backgroundColor": "#0c5cfa"
    },
    "goBackButton": {
        "position": "absolute",
        "marginLeft": 36,
        "width": 46,
        "height": 88,
        "top": 0,
        "backgroundPosition": "center"
    },
    "segmentControl": {
        "display": "flex",
        "flexDirection": "row",
        "aignItems": "center",
        "justifyContent": "center",
        "height": 60,
        "width": 360
    },
    "segmentLeftSelectedItem": {
        "background": "res://pearl_left_selected",
        "height": 60,
        "width": 154
    },
    "segmentLeftUnselectedItem": {
        "background": "res://pearl_left_unselected",
        "height": 60,
        "width": 154
    },
    "segmentRightSelectedItem": {
        "background": "res://pearl_right_selected",
        "height": 60,
        "width": 154
    },
    "segmentRightUnselectedItem": {
        "background": "res://pearl_right_unselected",
        "height": 60,
        "width": 154
    },
    "header": {
        "position": "absolute",
        "backgroundColor": "#0c5cfa",
        "height": 362,
        "width": 750,
        "display": "flex",
        "flexDirection": "row",
        "alignItems": "center"
    },
    "headIcon": {
        "marginLeft": 36,
        "height": 172,
        "width": 172,
        "borderRadius": 86,
        "force": "true"
    },
    "simpleInfo": {
        "marginLeft": 36,
        "height": 180,
        "width": 500,
        "display": "flex",
        "flexDirection": "column"
    },
    "simpleInfoL1": {
        "fontSize": 50,
        "color": "#ffffff",
        "maxLines": 1
    },
    "simpleInfoL2": {
        "fontSize": 28,
        "color": "#ffffff",
        "marginTop": 18,
        "maxLines": 1
    },
    "simpleInfoL3": {
        "fontSize": 28,
        "color": "#ffffff",
        "marginTop": 14,
        "maxLines": 1
    },
    "pearlListBox": {
        "position": "absolute",
        "top": 362,
        "width": 750,
        "height": 846,
        "display": "flex",
        "backgroundColor": "#ffffff",
        "flexDirection": "column"
    },
    "pearlListItem": {
        "height": 90,
        "width": 750,
        "alignItems": "center",
        "display": "flex",
        "flexDirection": "row"
//        "justifyContent":"space-between"
    },
     "pearlListItemContainer": {
          "height": 90,
          "width": 580,
          "alignItems": "center",
          "display": "flex",
          "flexDirection": "row"
      },
    "pearlListImg": {
        "height": 36,
        "width": 36,
        "marginLeft": 36
    },
    "pearlListRightArrow":{
        "height": 32,
        "width": 32,
        "marginLeft": 36,
//        "marginRight": 24,
    },
    "pearlMobileBindIcon":{
        "height": 38,
        "width": 96,
        "marginLeft": 36
    },
    "pearlMobileBindIconHidden":{
        "display":"none"
    },
    "pearlListRightArrowHidden":{
        "display":"none"
    },
    "pearlListText": {

        "fontSize": 34,
        "marginLeft": 36,
        "maxLines": 1
    },
    "relationshipPanel": {
        "width": 750,
        "height": 294,
        "display": "flex",
        "flexDirection": "column"
    },
    "relationshipTitle": {
        "color": "#000000",
        "fontSize": 28,
        "marginTop": 20,
        "marginLeft": 36
    },
    "relationshipList": {
        "marginTop": 30,
        "marginLeft": 36,
        "display": "flex",
        "flexDirection": "row",
        "height": 206
    },
    "relationshipItem": {
        "marginRight": 30,
        "width": 150,
        "display": "flex",
        "flexDirection": "column",
        "alignItems": "center"
    },
    "relationshipItemImg": {
        "height": 100,
        "width": 100,
        "borderRadius": 50
    },
    "relationshipItemDesc1Wrapper": {
        "marginTop": 14,
        "width": 150,
        "display": "flex",
        "flexDirection": "row",
        "alignItems": "center",
        "justifyContent":"center"
    },
    "relationshipItemDesc1": {
        "textAlign": "center",
        "color": "#000000",
        "fontSize": 22,
        "width": 120,
        "maxLines": 1
    },
    "relationshipItemDesc1FullLength": {
        "textAlign": "center",
        "color": "#000000",
        "fontSize": 22,
        "width": 150,
        "maxLines": 1
    },
    "verityIcon": {
        "height": 30,
        "width": 30
    },
    "verityIconHidden": {
        "display": "none"
    },
    "relationshipItemDesc2": {
        "marginTop": 10,
        "textAlign": "center",
        "color": "#808080",
        "fontSize": 22,
        "width": 150,
        "maxLines": 1
    },
    "bottomPanel": {
        "position": "absolute",
        "height": 108,
        "width": 750,
        "bottom": 0,
        "display": "flex",
        "flexDirection": "row",
        "alignItems": "center",
        "backgroundColor": "#ffffff",
        "justifyContent": "center"
    },
    "bottomSingleButton": {
        "width": 702,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#ffffff",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "marginLeft": 24,
        "marginRight": 24
    },
    "bottomLeftButton": {
        "width": 338,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#ffffff",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "marginLeft": 24,
        "marginRight":12
    },
    "bottomRightButton": {
        "width": 338,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#0c5cfa",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "marginRight": 24,
        "marginLeft":12,
        "color":"#ffffff"
    },
    "bottomFirstButton": {
        "width": 218,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#ffffff",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "marginRight": 12,
        "marginLeft": 24
    },
    "bottomSecondButton": {
        "width": 218,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#ffffff",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "marginRight": 12,
        "marginLeft": 12
    },
    "bottomThirdButton": {
        "width": 218,
        "height": 76,
        "fontSize": 34,
        "backgroundColor": "#0c5cfa",
        "borderWidth": 1,
        "borderColor": "#bcc2c8",
        "color":"#ffffff",
        "marginRight": 24,
        "marginLeft": 12
    },
    "favIconUnselected":{
        "width":48,
        "height":48,
        "background": "res://icon_fav_add",
        "marginLeft": 670,
        "top":20,
        "position": "absolute"


    },
    "favIconSelected":{
       "width":48,
       "height":48,
       "background": "res://icon_fav_add_selected",
       "marginLeft": 670,
       "top":20,
       "position": "absolute"
    },
    "favIconHidden":{
        "display":"none"
    },


},

"template":{
    "type": "div",
    "id": "profile",
    "classList": [
    "profile"
    ],
    "children": [
    {
       "type": "statusBar",
       "id": "statusBar",
       "classList": [
       "statusBar"
       ]
   },
   {
       "type": "div",
       "id": "navigationBar",
       "classList": [
       "navigationBar"
       ],
       "children": [
       {
          "type": "div",
          "id": "segmentControl",
          "classList": [
          "segmentControl"
          ],
          "children": [
          {
             "type": "button",
             "id": "segmentLeftButton",
             "classList": [
             "segmentLeftSelectedItem"
             ],
             "events": {
                "onClick": "showExternalProfile"
            }
        },
        {
         "type": "button",
         "id": "segmentRightButton",
         "classList": [
         "segmentRightUnselectedItem"
         ],
         "events": {
            "onClick": "showInternalProfile"
        }
    }
    ]
}
]
},
{
   "type": "image",
   "id": "goBackButton",
   "classList": [
   "goBackButton"
   ],
   "events": {
       "onClick": "goBack"
   },
   "attr": {
       "src": "res://pearl_header_user_leftbtn_nor"
   }
},
{
     "type": "button",
     "id": "favIcon",
     "classList": [
       "favIconUnselected"
       ],
     "events": {
     "onClick": "favIconClick"
     }
},
{
   "type": "div",
   "id": "innerProfile",
   "classList": [
   "innerProfile"
   ],
   "children": [
   {
      "type": "div",
      "classList": [
      "header"
      ],

      "children": [
      {
         "type": "image",
         "id": "headIcon",
         "attr": {
             "src": "res://pearl_headicon"
         },
        "events": {
            "onClick": "showIcon"
         },
         "classList": [
         "headIcon"
         ]
     },
     {
         "type": "div",
         "classList": [
         "simpleInfo"
         ],
         "children": [
         {
            "type": "text",
            "classList": [
            "simpleInfoL1"
            ],
            "attr": {
                "value": ""
            }
        },
        {
            "type": "text",
            "classList": [
            "simpleInfoL2"
            ],
            "attr": {
                "value": ""
            }
        },
        {
            "type": "text",
            "classList": [
            "simpleInfoL3"
            ],
            "attr": {
                "value": ""
            }
        }
        ]
    }
    ]
},
{
  "type": "scroller",
  "classList": [
  "pearlListBox"
  ],
  "children": [
  {
     "type": "div",
     "classList": [
     "pearlListItem"
     ],
     "events": {
         "onClick": "itemClick"
     },
     "children": [
     {
        "type": "image",
        "classList": [
        "pearlListImg"
        ],
        "attr": {
            "src": "res://pearl_ico_qidian"
        }
    },
    {
         "type": "div",
         "classList": [
          "pearlListItemContainer"
          ],
          "children": [
           {
               "type": "text",
                 "classList": [
                     "pearlListText"
                 ],
               "attr": {
                    "value": ""
                }
           },
           {
               "type": "image",
               "classList": [
                   "pearlMobileBindIcon"
                ],
                "attr": {
                   "src": "res://qidian_profile_binded"
                 }
           }
         ]
     },
    {
        "type": "image",
        "classList": [
                    "pearlListRightArrow"
                    ],
        "attr": {
        "src": "res://ico_back_right"
        }
    }
    ]
}
]
},
{
  "type": "div",
  "id": "innerBottomPanel",
  "classList": [
  "bottomPanel"
  ],
  "children": [
  {
     "type": "button",
     "classList": [
     "bottomSingleButton"
     ],
     "events": {
         "onClick": "editInnerProfile"
     },
     "attr": {
         "value": "编辑资料"
     }
 }
 ]
}
]
},
{
   "type": "div",
   "id": "outerProfile",
   "classList": [
   "outerProfile"
   ],
   "children": [
   {
      "type": "div",
      "classList": [
      "header"
      ],
      "children": [
      {
         "type": "image",
         "attr": {
             "src": "res://pearl_headicon"
         },
         "events": {
            "onClick": "showIcon"
         },
         "classList": [
         "headIcon"
         ]
     },
     {
         "type": "div",
         "classList": [
         "simpleInfo"
         ],
         "children": [
         {
            "type": "text",
            "classList": [
            "simpleInfoL1"
            ],
            "attr": {
                "value": ""
            }
        },
        {
            "type": "text",
            "classList": [
            "simpleInfoL2"
            ],
            "attr": {
                "value": ""
            }
        },
        {
            "type": "text",
            "classList": [
            "simpleInfoL3"
            ],
            "attr": {
                "value": ""
            }
        }
        ]
    }
    ]
},
{
  "type": "scroller",
  "classList": [
  "pearlListBox"
  ],
  "children": [
  {
     "type": "div",
     "classList": [
     "pearlListItem"
     ],
     "events": {
         "onClick": "itemClick"
     },
     "children": [
     {
        "type": "image",
        "classList": [
        "pearlListImg"
        ],
        "attr": {
            "src": "res://pearl_ico_qidian"
        }
    },
     {
             "type": "div",
             "classList": [
              "pearlListItemContainer"
              ],
              "children": [
               {
                   "type": "text",
                     "classList": [
                         "pearlListText"
                     ],
                   "attr": {
                        "value": ""
                    }
               },
               {
                   "type": "image",
                   "classList": [
                       "pearlMobileBindIcon"
                    ],
                    "attr": {
                       "src": "res://qidian_profile_binded"
                     }
               }
             ]
     },
    {
       "type": "image",
       "classList": [
                "pearlListRightArrow"
                ],
       "attr": {
       "src": "res://ico_back_right"
       }
    }
    ]
},
{
 "type": "div",
 "id": "relationshipPanel",
 "classList": [
 "relationshipPanel"
 ],
 "children": [
 {
    "type": "text",
    "classList": [
    "relationshipTitle"
    ],
    "attr": {
        "value": "相关推荐"
    }
},
{
    "type": "scroller",
    "id": "relationshipList",
    "classList": [
    "relationshipList"
    ],
    "children": [
    {
       "type": "div",
       "classList": [
       "relationshipItem"
       ],
       "children": [
       {
          "type": "image",
          "classList": [
          "relationshipItemImg"
          ],
          "attr": {
              "src": ""
          }
      },
        {
            "type": "div",
            "classList": [
                          "relationshipItemDesc1Wrapper"
                          ],
            "children": [
                         {
                         "type": "text",
                         "classList": [
                                       "relationshipItemDesc1"
                                       ],
                         "attr": {
                         "value": ""
                         }
                         },
                         {
                         "type": "image",
                         "classList": [
                                       "verityIcon"
                                       ],
                         "attr": {
                         "src": ""
                         }
                         }
                         ]
        },
      {
          "type": "text",
          "classList": [
          "relationshipItemDesc2"
          ],
          "attr": {
              "value": ""
          }
      }
      ]
  }
  ]
}
]
}
]
},
{
  "type": "div",
  "id": "outerBottomPanel",
  "classList": [
  "bottomPanel"
  ],
  "children": [
  {
     "type": "button",
     "classList": [
     "bottomSingleButton"
     ],
     "events": {
         "onClick": "editOuterProfile"
     },
     "attr": {
         "value": "编辑资料"
     }
 }
 ]
}
]
}
]
},

"script":{
    "test" : function(params, params2) {
        Toast.show("ssss");
        PearlOrganization.jumpTo("返回",1);
    },
    "test1" : function(params, params2) {
        Toast.show("ssss");
        PearlOpenAIO.openAioFromCard("2852997543","sss");
    },
    "test2" : function(params, params2) {
        Toast.show("ssss");
        PearlMultiPhone.enterQQPhoneFromCard("2852997543","sss");
    },
    "test3" : function(params, params2) {
        Toast.show("ssss");
        var sendMsg = {"name":"发短信","type":4};
        var normalPhone = {"name":"普通电话","type":3};
        var callBackPhone = {"name":"回拨电话","type":2};
        var jsonWrapper = {"sendMsg":JSON.stringify(sendMsg),"normalPhone":JSON.stringify(normalPhone),"callBackPhone":JSON.stringify(callBackPhone)};
        PearlActionSheet.showCardSheet("展示电话","取消",JSON.stringify(jsonWrapper),"18317138763","2852997532","sss");
    },
    "test4" : function(params, params2) {
        Toast.show("ssss");
        PearlAvatar.viewAvatar("2852997222",9)
    },
    "test5" : function(params, params2) {
        Toast.show("ssss");
        PearlMultiPhone.openBindMobile();
    },
    "showInternalProfile":function(params)
    {
        ProfileSwitcher.showInternalProfile();
    },
    "showExternalProfile":function(params)
    {
        ProfileSwitcher.showExternalProfile();
    },
    "edit":function(params)
    {
        Toast.show("edit");
    },
    "qidian_call":function(params)
    {
//        Toast.show("qidian_call");
        Log.d("qidian_call click", "Person");
        var normalPhone = {"name":"普通电话","type":3};
        var callBackPhone = {"name":"回拨电话","type":2};
        var jsonWrapper = {"normalPhone":JSON.stringify(normalPhone),"callBackPhone":JSON.stringify(callBackPhone)};
        PearlActionSheet.showCardSheet("","取消",JSON.stringify(jsonWrapper),colleagueMobile,colleagueUin,colleagueName);
    },
    "qq_call":function(params)
    {
        Log.d("qq_call click", "Person");
        PearlMultiPhone.enterQQPhoneFromCard(colleagueUin,colleagueName);
    },
    "send_message":function(params)
    {
//        Toast.show("send_message");
        PearlOpenAIO.openAioFromCard(colleagueUin,colleagueName);
    },
    "itemClick":function(params)
    {
        Toast.show("itemClick");
    },
    "goBack":function(params)
    {
//        Toast.show("goBack");
        Log.d("goBack click", "Person");
        Page.popPage();

    },
    "callInternalTel":function(params)
    {
//        Toast.show("call");
        Log.d("call click", "Person");
        Phone.call(colleaguePhone);
    },
    "callInternalMobile":function(params)
    {
        Log.d("callInternalMobile click", "Person");
        var sendMsg = {"name":"发短信","type":4};
        var normalPhone = {"name":"普通电话","type":3};
        var jsonWrapper = {"sendMsg":JSON.stringify(sendMsg),"normalPhone":JSON.stringify(normalPhone)};
        PearlActionSheet.showCardSheet("","取消",JSON.stringify(jsonWrapper),colleagueMobile,colleagueUin,colleagueName);
    },
    "callExternalTel":function(params)
    {
        //        Toast.show("call");
        Log.d("callExternalTel click", "Person");
        Phone.call(colleagueExternalTel);
    },
    "callExternalMobile":function(params)
    {
        Log.d("callExternalMobile click", "Person");
        var sendMsg = {"name":"发短信","type":4};
        var normalPhone = {"name":"普通电话","type":3};
        var jsonWrapper = {"sendMsg":JSON.stringify(sendMsg),"normalPhone":JSON.stringify(normalPhone)};
        PearlActionSheet.showCardSheet("","取消",JSON.stringify(jsonWrapper),colleagueExternalMobile,colleagueUin,colleagueName);
    },
    "sendInternalMail":function(params)
    {
        Log.d("sendInternalMail click", "Person");
        EMail.send(colleagueMail,"Subject","Body");
    },
    "sendExternalMail":function(params)
    {
        Log.d("sendExternalMail click", "Person");
        EMail.send(colleagueExternalMail,"Subject","Body");
    },
    "jumpToOrg":function(params)
    {
        Log.d("jumpToOrg click", "Person");
        PearlOrganization.jumpTo("返回",colleagueOrgID);
    },
    "editOuterProfile":function(params)
     {
         var args = {"uin":selfUin,"type":"outside"};
         Page.openNewPage("QiDianEditProfileVC","com.tencent.qidian.profilecard.memberprofile.activity.QidianEditMemberProfileCardActivity",2000,args);
     },
     "editInnerProfile":function(params)
     {
         var args = {"uin":selfUin,"type":"inside"};
         Page.openNewPage("QiDianEditProfileVC","com.tencent.qidian.profilecard.memberprofile.activity.QidianEditMemberProfileCardActivity",2000,args);
     },
    "showIcon":function(params)
    {
        var uin = colleagueUin;
        if(uin.length == 0)
        {
            uin = selfUin;
        }
        PearlAvatar.viewAvatar(uin,headIconNativeId);
    },
    "bind":function(params)
    {
        PearlMultiPhone.openBindMobile();
    },
     "favIconClick":function(params)
     {
         if(isFavIconSelected)//已选中情况点击事件触发删除常用人逻辑
         {
             PearlFavContact.pearlDelFavContact(colleagueUin);
         }
         else
         {
             PearlFavContact.pearlAddFavContact(colleagueUin);
         }
     }

}

};

//记录当前资料卡信息，用于计算Diff
var currentProfileJson = "";
//同事数据
var colleagueUin = ""; //同事Uin
var selfUin = ""; //自己的Uin
var colleagueOrgID = "";//组织架构ID
var colleagueName = "";//同事名称
var colleagueMobile = "";//同事对内手机
var colleaguePhone = "";//同事对内电话
var colleagueExternalMobile = "";//对外手机
var colleagueExternalTel = "";//对外电话
var colleagueExternalMail = "";//对外邮箱
var colleagueMail = "";//邮箱
var isFavIconSelected = false; //收藏按钮是否被点亮
var headIconNativeId = 0;
function PersonStruct(jsonStr,isChangeInside) {
    if (typeof jsonStr === 'string' || jsonStr instanceof String) {
        json = JSON.parse(jsonStr);
    } else {
        json = jsonStr;
    }

    var uiJson = "";
    //addby mambacai
    if(currentProfileJson == "")
    {
        uiJson = JSON.parse(JSON.stringify(profileTemplate));
        uiJson.script = profileTemplate.script;
    }
    else
    {
        uiJson = currentProfileJson;
    }
   //常用联系人
    function updateFavIcon(profile,protoData)
    {
        var favIcon = profile.template.children[3];
        if(colleagueUin === selfUin || protoData.hasFavFunc == false)//本人的资料卡不需要展示
        {
            favIcon.classList[0] = "favIconHidden";
        }
        else
        {
            isFavIconSelected = protoData.isFav;
            if(isFavIconSelected == true)//是常用联系人
            {
                favIcon.classList[0] = "favIconSelected";
            }
            else
            {
                favIcon.classList[0] = "favIconUnselected";
            }
        }
    }
    //更新对内资料
    function updateInternalProfile(profile,protoData)
    {
        var header = profile.template.children[4].children[0];
        //image
        var image = header.children[0];
        if(image.type === 'image')
        {
            image.attr.src = "uin://"+protoData.internalInfo.uin;
            image.attr.placeholder = "res://image_default";
            image.attr.fail = "res://image_default_fail";
        }
        //simpleInfo
        var simpleInfo = header.children[1];
        simpleInfo.children[0].attr.value = protoData.internalInfo.name;
        simpleInfo.children[1].attr.value = protoData.internalInfo.account;
        simpleInfo.children[2].attr.value = protoData.corpInfo.corpName;
        colleagueName = protoData.internalInfo.name;
        //list
        var scroller = profile.template.children[4].children[1];
        var itemCount = 0;

        //sign
        if(protoData.internalInfo.sign != null)
        {

            if(protoData.internalInfo.sign.length > 0)
            {
                generateScrollerItem(itemCount++,"res://pearl_ico_pen",protoData.internalInfo.sign,scroller);
            }
        }

        //job
        if(protoData.internalInfo.jobs != null)
        {
            //需要有canDisplay权限才展示职位信息
            if(protoData.canDisplay == true && protoData.internalInfo.jobs.length > 0)
            {
                var jobInfo = protoData.internalInfo.jobs[0];
                var value = jobInfo.orgName + " " + jobInfo.job;
                colleagueOrgID = jobInfo.orgId;
                var item = generateScrollerItem(itemCount++,"res://pearl_ico_structure", value ,scroller);
                item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                item.events.onClick = "jumpToOrg";
            }
        }

        //mobile
        if(protoData.internalInfo.mobile != null)
        {
            var item;
            if(colleagueUin === selfUin)//自己的资料卡展示绑定手机入口
            {
                var mobileText = "";
                if(protoData.internalInfo.mobile.length > 0)
                {
                    mobileText = protoData.internalInfo.mobile;
                }
                else
                {
                    mobileText = "绑定手机";
                }
                item = generateScrollerItem(itemCount++,"res://pearl_ico_phone",mobileText,scroller);
                item.events.onClick = "bind";
                item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                //自己的资料卡，已经绑定手机，显示绑定icon
                if(protoData.internalInfo.mobile.length > 0 && protoData.internalInfo.isMobileBind === "true"){
                     item.children[1].children[1].classList[0] = "pearlMobileBindIcon";
                }
                colleagueMobile = protoData.internalInfo.mobile;
            }
            else
            {
                if(protoData.internalInfo.mobile.length > 0)
                {
                    item = generateScrollerItem(itemCount++,"res://pearl_ico_phone",protoData.internalInfo.mobile,scroller);
                    item.events.onClick = "callInternalMobile";
                    item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                    colleagueMobile = protoData.internalInfo.mobile;
                }

            }
        }

        //tel
        if(protoData.internalInfo.tel != null)
        {
            if(protoData.internalInfo.tel.length > 0)
            {
                var item = generateScrollerItem(itemCount++,"res://pearl_ico_call",protoData.internalInfo.tel,scroller);
                item.events.onClick = "callInternalTel";
                item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                colleaguePhone = protoData.internalInfo.tel;
            }
        }

        //mail
        if(protoData.internalInfo.regularMail != null)
        {
            if(protoData.canDisplay == true && protoData.internalInfo.regularMail.length > 0)
            {
                var item = generateScrollerItem(itemCount++,"res://pearl_ico_mail",protoData.internalInfo.regularMail,scroller);
                item.events.onClick = "sendInternalMail";
                item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                colleagueMail = protoData.internalInfo.regularMail;
            }

        }

        //uin
        if(protoData.internalInfo.uin != null)
        {
            generateScrollerItem(itemCount++,"res://pearl_ico_qidian",protoData.internalInfo.uin,scroller);
        }

        //gender && location
         var gender_location = protoData.internalInfo.gender;
         if(protoData.internalInfo.country != ""){
             gender_location = gender_location + " " + protoData.internalInfo.country;
         }
         if(protoData.internalInfo.province != ""){
             gender_location = gender_location + "-" + protoData.internalInfo.province;
         }
         if(protoData.internalInfo.city != ""){
             gender_location = gender_location + "-" + protoData.internalInfo.city;
         }
        if(gender_location.trim().length > 0)
        {
            generateScrollerItem(itemCount++,"res://pearl_ico_contacts",gender_location,scroller);
        }

//        Log.d("internalProfile : scroller before clean extra :" + JSON.stringify(scroller) , "Person");
        //清除scroller中多余items
        if(itemCount < scroller.children.length)
        {
            scroller.children.splice(itemCount,scroller.children.length - itemCount);
//            Log.d("internalProfile : scroller after clean extra:" + JSON.stringify(scroller) , "Person");
        }

        var bottomPanel = generateBottomPanel(profileTemplate.template.children[4].children[2], protoData.touchData);
        profile.template.children[4].children[2] = bottomPanel;
        var style = profile.style;
        if(gIsShowSelfPreview){ //预览不需要编辑按钮，同时scroll拉伸
          style.bottomPanel.display = "none";
          style.pearlListBox.height = 846;
        }else{
          delete style.bottomPanel.display;
          style.pearlListBox.height = 738;
        }
        Log.d("updateInternalProfile result:" + JSON.stringify(profile.template), "Person");
    }

    //更新对外资料
    function updateExternalProfile(profile,protoData)
    {
        //判断是否有展示对外资料权限
//        if(protoData.externalInfo.privFlag === '0')
//        {
            //TODO:无对外权限情况暂不处理
            //无对外权限时 屏蔽导航栏的按钮以及对外资料卡权限
//            profile.template.children[4] = {};
//            profile.template.children[1].children = {};
//        }
//        else
        {
            var header = profile.template.children[5].children[0];
            //image
            var image = header.children[0];
            if(image.type === 'image')
            {
                image.attr.src = "uin://"+protoData.externalInfo.uin;
                image.attr.placeholder = "res://image_default";
                image.attr.fail = "res://image_default_fail";
            }

            //simpleInfo
            var simpleInfo = header.children[1];
            simpleInfo.children[0].attr.value = protoData.externalInfo.nickname;
            simpleInfo.children[1].attr.value = protoData.externalInfo.job;
            simpleInfo.children[2].attr.value = protoData.corpInfo.corpName;

            //list
            var scroller = profile.template.children[5].children[1];
            var itemCount = 0;

            //相关推荐列表预处理，相关推荐列表默认是scroller的最后一个节点，如果最后一个节点不存在或者最后一个节点不是相关推荐的模版，则从profileTemplate中重新获取
            var scrollerLength = scroller.children.length;
            var relationshipPanel;
            if(scrollerLength > 0)
            {
                var lastChild = scroller.children[scrollerLength - 1];
//                Log.d("externalprofile : lastChild in scroller:" + JSON.stringify(lastChild), "Person");
                if(lastChild.id == "relationshipPanel")
                {
                    relationshipPanel = lastChild;
                    //方便计算，将relationshipPanel单独抽取出来
                    scroller.children.splice(scrollerLength - 1, 1);
//                    Log.d("externalprofile : scroller without relationlist:" + JSON.stringify(scroller), "Person");
                }
            }
            if(relationshipPanel == null)
            {
                relationshipPanel = JSON.parse(JSON.stringify(profileTemplate.template.children[5].children[1].children[1]));
            }
            var relationshipList = relationshipPanel.children[1];

            //sign
            if(protoData.externalInfo.sign != null)
            {
                if(protoData.externalInfo.sign.length > 0)
                {
                    generateScrollerItem(itemCount++,"res://pearl_ico_pen",protoData.externalInfo.sign,scroller);
                }
            }

            //mobile
            if(protoData.externalInfo.mobile != null)
            {
                if(protoData.externalInfo.mobile.length > 0)
                {
                    var item = generateScrollerItem(itemCount++,"res://pearl_ico_phone",protoData.externalInfo.mobile,scroller);
                    colleagueExternalMobile = protoData.externalInfo.mobile;
                    item.events.onClick = "callExternalMobile";
                    item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                }
            }

            //tel
            if(protoData.externalInfo.tel != null)
            {
                if(protoData.externalInfo.tel.length > 0)
                {
                    var item = generateScrollerItem(itemCount++,"res://pearl_ico_call",protoData.externalInfo.tel,scroller);
                    colleagueExternalTel = protoData.externalInfo.tel;
                    item.events.onClick = "callExternalTel";
                    item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                }
            }

            //mail
            if(protoData.externalInfo.mail != null)
            {
                if(protoData.externalInfo.mail.length > 0)
                {
                    var item = generateScrollerItem(itemCount++,"res://pearl_ico_mail",protoData.externalInfo.mail,scroller);
                    item.events.onClick = "sendExternalMail";
                    colleagueExternalMail = protoData.externalInfo.mail;
                    item.children[item.children.length - 1].classList[0] = "pearlListRightArrow";
                }

            }

            //gender && location
           var gender_location = protoData.externalInfo.gender;
           if(protoData.externalInfo.country != ""){
              gender_location = gender_location + " " + protoData.externalInfo.country;
           }
           if(protoData.externalInfo.province != ""){
              gender_location = gender_location + "-" + protoData.externalInfo.province;
           }
            if(protoData.externalInfo.city != ""){
               gender_location = gender_location + "-" + protoData.externalInfo.city;
            }
            if(gender_location.trim().length > 0)
            {
                generateScrollerItem(itemCount++,"res://pearl_ico_contacts",gender_location,scroller);
            }

            // 关联企业
            if(protoData.externalInfo.associatedEnterpriseName != null)
            {
                if(protoData.externalInfo.associatedEnterpriseName.length > 0)
                {
                    generateScrollerItem(itemCount++,"res://pearl_ico_associated_enterprise",protoData.externalInfo.associatedEnterpriseName,scroller);
                }
            }

            if(itemCount < scroller.children.length)
            {
                scroller.children.splice(itemCount,scroller.children.length - itemCount);
            }
//            Log.d("externalprofile : scroller before add realationlist:" + JSON.stringify(scroller), "Person");
            //相关推荐列表
            var relationshipItemTemplate = JSON.parse(JSON.stringify(profileTemplate.template.children[5].children[1].children[1].children[1].children[0]));

            var pubAccItemsCount = 0;
            if(protoData.externalInfo.pubAccItems != null)
            {
                pubAccItemsCount = protoData.externalInfo.pubAccItems.length;
            }

            for (var i = 0; i < pubAccItemsCount; i ++)
            {
                var pubAccItemData = protoData.externalInfo.pubAccItems[i];
                var pubAccItem;
               /* if(i < relationshipList.children.length)
                {
                    pubAccItem = relationshipList.children[i];
                }*/
                //else
               // {
                    pubAccItem = JSON.parse(JSON.stringify(relationshipItemTemplate));
                //}
                if(pubAccItemData.type == "1")//微信公众号
                {
                    pubAccItem.children[0].attr.src = pubAccItemData.faceUrl;
                    pubAccItem.children[2].attr.value = "微信公众号";
                    if(pubAccItemData.verity == "1")
                    {
                        pubAccItem.children[1].children[1].attr.src = "res://qidian_weixin_certified_icon";
                        //pubAccItem.children[1].children[1].classList[0] = "verityIcon";
                    }
                    else
                    {
                        pubAccItem.children[1].children.splice(1, 1);
                        pubAccItem.children[1].children[0].classList[0] = "relationshipItemDesc1FullLength";

                    }
                }
                else//QQ公众号
                {
                    pubAccItem.children[0].attr.src = "uin://" + pubAccItemData.uin;
                    pubAccItem.children[2].attr.value = "QQ公众号";
                    if(pubAccItemData.verity == "1")
                    {
                        pubAccItem.children[1].children[1].attr.src = "res://qb_pubaccount_avatar_icon";
                        //pubAccItem.children[1].children[1].classList[0] = "verityIcon";
                    }
                    else
                    {
                        pubAccItem.children[1].children.splice(1, 1);
                        pubAccItem.children[1].children[0].classList[0] = "relationshipItemDesc1FullLength";
                    }
                }
                pubAccItem.children[0].attr.placeholder = "res://image_default";
                pubAccItem.children[0].attr.fail = "res://image_default_fail";
                pubAccItem.children[1].children[0].attr.value = pubAccItemData.name;

                relationshipList.children[i] = pubAccItem;
            }

            var groupItemsCount = 0;

            if(protoData.externalInfo.groupItems != null)
            {
                groupItemsCount = protoData.externalInfo.groupItems.length;
            }

            for(var i = 0; i < groupItemsCount; i ++)
            {
                var groupItemData = protoData.externalInfo.groupItems[i];
                var groupItem;

                groupItem = JSON.parse(JSON.stringify(relationshipItemTemplate));
                groupItem.children[0].attr.src = "groupCode://"+groupItemData.groupid;
                groupItem.children[1].children.splice(1, 1);
                groupItem.children[1].children[0].classList[0] = "relationshipItemDesc1FullLength";
                groupItem.children[1].children[0].attr.value = groupItemData.name;
                groupItem.children[2].attr.value = "群组";

                relationshipList.children[pubAccItemsCount + i] = groupItem;
            }

//            Log.d("externalprofile : relationshipPanel before clean extra items:" + JSON.stringify(relationshipPanel), "Person");

            //删除relationshipList多余节点
            if(pubAccItemsCount + groupItemsCount < relationshipList.children.length)
            {
                relationshipList.children.splice(pubAccItemsCount + groupItemsCount, relationshipList.children.length - pubAccItemsCount - groupItemsCount);

//                Log.d("externalprofile : relationshipPanel after clean extra items:" + JSON.stringify(relationshipPanel), "Person");
            }
            //相关推荐如果内容为空，不展示该节点
            if(groupItemsCount + pubAccItemsCount > 0)
            {
                scroller.children[itemCount++] = relationshipPanel;
            }

            var bottomPanel = generateBottomPanel(profileTemplate.template.children[5].children[2], protoData.touchData);
            profile.template.children[5].children[2] = bottomPanel;
            var style = profile.style;
            if(gIsShowSelfPreview){ //预览不需要编辑按钮，同时scroll拉伸
              style.bottomPanel.display = "none";
              style.pearlListBox.height = 846;
            }else{
              delete style.bottomPanel.display;
              style.pearlListBox.height = 738;
            }
            Log.d("updateExternalProfile result: " + JSON.stringify(profile.template), "Person");

        }
    }

    //生成资料卡底部按钮
    function generateBottomPanel(bottomPanelJson,touchData)
    {
        var bottomPanel = JSON.parse(JSON.stringify(bottomPanelJson));
        var bottomButtonTemplate = bottomPanel.children[0];

        var touchDataCount = touchData.length;

        //单个按钮
        if(touchDataCount == 1)
        {
            var button = JSON.parse(JSON.stringify(bottomButtonTemplate));
            button.classList[0] = "bottomSingleButton";

            bottomPanel.children[0] = button;
        }
        //两个按钮
        else if(touchDataCount == 2)
        {
            var leftButton  = JSON.parse(JSON.stringify(bottomButtonTemplate));
            var rightButton = JSON.parse(JSON.stringify(bottomButtonTemplate));

            leftButton.classList[0] = "bottomLeftButton";
            rightButton.classList[0] = "bottomRightButton";

            bottomPanel.children[0] = leftButton;
            bottomPanel.children[1] = rightButton;
        }
        //三个按钮
        else if(touchDataCount == 3)
        {
            var firstButton = JSON.parse(JSON.stringify(bottomButtonTemplate));
            var secondButton = JSON.parse(JSON.stringify(bottomButtonTemplate));
            var thirdButton = JSON.parse(JSON.stringify(bottomButtonTemplate));

            firstButton.classList[0] = "bottomFirstButton";
            secondButton.classList[0] = "bottomSecondButton";
            thirdButton.classList[0] = "bottomThirdButton";

            bottomPanel.children[0] = firstButton;
            bottomPanel.children[1] = secondButton;
            bottomPanel.children[2] = thirdButton;
        }

        for(var i = 0; i < touchDataCount; i ++)
        {
            var name = touchData[i].type;
            var button = bottomPanel.children[i];

            if(name == "edit")
            {   //使用模版默认的点击事件即可
//                button.events.onClick = name;
                button.attr.value = "编辑资料";
            }
            else if(name == "qidian_call")
            {
                button.events.onClick = name;
                button.attr.value = "企业电话";
            }
            else if(name == "qq_call")
            {
                button.events.onClick = name;
                button.attr.value = "QQ电话";
            }
            else if(name == "send_message")
            {
                button.events.onClick = name;
                button.attr.value = "发消息";
            }
        }
//        Log.d("generateBottomPanel : " + JSON.stringify(bottomPanel), "Person");
        return bottomPanel;

    }

    //用于生成资料卡列表中某一列的数据
    function generateScrollerItem(index,resPath,value,scroller)
    {
        var newItem;
        if(index < scroller.children.length)
        {
            newItem = scroller.children[index];
        }
        else
        {
            var listItemTemplate = profileTemplate.template.children[4].children[1].children[0];
            newItem = JSON.parse(JSON.stringify(listItemTemplate));
        }

        newItem.children[0].attr.src = resPath;
        newItem.children[1].children[0].attr.value = value;

        //最后一个节点是向右箭头，手机号BindIcon默认隐藏
        newItem.children[1].children[1].classList[0] = "pearlMobileBindIconHidden";
        //最后一个节点是向右箭头，默认隐藏
        newItem.children[newItem.children.length - 1].classList[0] = "pearlListRightArrowHidden";
        scroller.children[index] = newItem;
        delete newItem.events.onClick;
        Log.d("generateScrollerItem : " + JSON.stringify(newItem), "Person");
        return newItem;
    }


    function convert() {
        updateFavIcon(uiJson,json);
        updateInternalProfile(uiJson,json);
        updateExternalProfile(uiJson,json);
        currentProfileJson = uiJson;
        if(isChangeInside){
          ProfileSwitcher.switchInternalProfile();
        }
        Log.d("PersonStruct convert : " + JSON.stringify(currentProfileJson), "Person");
    }

    convert();

    var _PersonStruct = {
        internalInfo: json.internalInfo,
        externalInfo: json.externalInfo,
        corpInfo: json.corpInfo,
        uin: json.uin,
        getUiJson: function() {
            return uiJson;
        },
        setUiJson: function(inJsonStr) {
            if (typeof inJsonStr === 'string' || inJsonStr instanceof String) {
                uiJson = JSON.parse(inJsonStr);
            } else {
                uiJson = inJsonStr;
            }
        }
    };
    return _PersonStruct;
}
var gIsShowSelfPreview = false;
__d(function(module) {
    require("Toast");
    require("EMail");
    require("Phone");
    require("Page");
    require("ViewCreater");
    require("Lifecycle");
    require("CallbackTest");
    require("PearlLoadData");
    require("Timer");
    require("PearlOrganization");
    require("PearlOpenAIO");
    require("PearlMultiPhone");
    require("PearlActionSheet");
    require("PearlAvatar");
    require("ProfileSwitcher");
    require("PearlFavContact");
    var RealLifecycleListener = LifecycleListener.extend({
       onResume: function () {

       },
       onPause: function () {
           Log.d("sub onPause");
       },
   });
    var listener = RealLifecycleListener.create({});
    var inner = "SomePri";
    var index = 0;
    var Person = {
        run: function run(uin, curUin,isSelfProfilePreview,isViewInside) {

    colleagueUin = uin;
    selfUin = curUin;

    // 默认头像和uin
    Log.d("Person run uin: " + uin + " | curUin: " + curUin + " | isSelfProfilePreview" + isSelfProfilePreview, "Person");
    var loadFromeNetSuccess = false;
    gIsShowSelfPreview = isSelfProfilePreview === "false" ? false : true;
    var isChangeInside = isViewInside === "true" ? true : false;
    if(gIsShowSelfPreview){
      PearlLoadData.loadDataFromPreview(uin, function(json) {
          Log.d("loadDataFromPreview uin: " + uin + " | json: " + json, "Person");
          PearlLoadData.onLoaded(json,isChangeInside);
      });
    }else{
        PearlLoadData.loadDataFromDB(uin, function(json) {
            if (!loadFromeNetSuccess) {
                Log.d("loadDataFromDB uin: " + uin + " | json: " + json, "Person");
                PearlLoadData.onLoaded(json,isChangeInside);
            }
        });

        PearlLoadData.loadDataFromNet(uin, function(json) {
          loadFromeNetSuccess = true;
          //Timer.clearTimeout(handler);
          Log.d("loadDataFromNet uin: " + uin + " | json: " + json, "Person");
          PearlLoadData.onLoaded(json,isChangeInside);
        });
    }
    //PearlLoadData.onLoaded("{}");
    //Lifecycle.addListener(listener);
    /*CallbackTest.test(function (parms1, params2) {
     Toast.show("CallbackTest:" + parms1 + " | " + params2);
 });*/
    //EventDispatcher.dispatch("40", "onClick", ["ss", "vv"]);
}
};
module.exports = Person;
}, "Person");
